package DataPreprocessing;
/*Clase que nos permite calcular los atributos TotalInstancesThisHour,MDPreviousPosition,MediumDistance por celda*/
public class CalculateAttributes {
    /*Creamos 3 array de 7*24 donde las filas representan los dias y las columnas las horas y cada uno se utiliza para un respectivo atributo*/
    private int [][] saveNumberOfInstancesPerHour; 
    private double [][] dPreviousPosition;
    private static SaveLatitudeAndLongitudePerHour save [][];
    
    public CalculateAttributes(){
        saveNumberOfInstancesPerHour = new int[7][24];
        dPreviousPosition = new double[7][24];
        save = new SaveLatitudeAndLongitudePerHour[7][24];
        startSaveLatitudeAndLongitude();
        
    }
    /*Almacenar que hay una instancia para un día y una hora concreta de una celda*/
    public void saveOneInstanceInHour(int day, int hour){
        saveNumberOfInstancesPerHour[day][hour] += 1; 
    }
    /*Obtener número de instancias que hay para un día y una hora concreta*/
    public int getNumberOfInstancesPerHour(int day,int hour){
        return saveNumberOfInstancesPerHour[day][hour];
    }
    /*Almacenar una posición previa a un coche para un día y una concreta*/
    public void saveDPreviousPosition(int day, int hour,double value){
        dPreviousPosition[day][hour] += value; 
    }
    /*Almacenar la latitud y longitud de una instancia a un día y una hora concreta para posteriormente calcular la distancia media*/
    public void saveLatitudeAndLongitude(int day,int hour, double latitude, double longitude){
        save[day][hour].add(latitude, longitude);
    }
    /*Calcular la distancia media*/
    public double mediumDistance(int day,int hour){
        return save[day][hour].distance();
    }
    /*Obtener la posición previa a una posicion a una hora y dia concreto*/
    public double getDPreviousPosition(int day,int hour){
        return dPreviousPosition[day][hour];
    }
    /*Reiniciar array donde almacenamos los atributos*/
    public void restart(){
        for(int i = 0; i<7;i++){
            for(int j= 0; j<24;j++){
                saveNumberOfInstancesPerHour[i][j] = 0;
                dPreviousPosition[i][j] = 0;
                if(save[i][j].tam() != 0){
                    save[i][j].clean();
                }
            }
        }
    }
    /*Crear las dos listas para almacenar latitud y longitud*/
    public static void startSaveLatitudeAndLongitude(){
        for(int i = 0; i<7;i++){
            for(int j= 0; j<24;j++){
                save[i][j] = new SaveLatitudeAndLongitudePerHour() ;
            }
        }
    }
    public void print(int date, int hour){
        System.out.println("Numero de instancias en dicha fecha " + date + " " + hour +  " " + saveNumberOfInstancesPerHour[date][hour]);
    }
}
