package DataPreprocessing;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
/*Clase que se utiliza para calcular el flujo de entrada y salida de tráfico para una celda
Además se utiliza para calcular la N critica la cual utiliza para etiquetar una instancia*/
public class CalculateFlushCar {
    /*Array 7*24 para almacenar los taxis que pasan a un día y hora concreta. Lista para almacenar 
    flujo de salida de tráfico y el numero de taxis*/
    private SaveIDTaxisPerHour save [][];
    private ArrayList<SaveOutFlowAndNumTaxis> saveOutFlowAndNumTaxis;
    public  CalculateFlushCar(){
        save = new SaveIDTaxisPerHour[7][24];
        saveOutFlowAndNumTaxis = new ArrayList<SaveOutFlowAndNumTaxis>();
        start();
    }
    /*Lista para almacenar los id de taxis*/
    public void start(){
        for(int i  = 0; i<7;i++){
            for(int j = 0; j<24;j++){
                save[i][j] = new SaveIDTaxisPerHour();
            }
        }    
    }
    /*Reiniciar listas donde almacenamos los id de taxis*/
    public void restart(){
        for(int i  = 0; i<7;i++){
            for(int j = 0; j<24;j++){
                if(save[i][j].tam() != 0){
                    save[i][j].clean();
                }
            }
        }
        saveOutFlowAndNumTaxis.clear();
    }
    /*Almacenar el id de taxis para un día y hora concreto*/
    public void saveIDTaxis(int day, int hour,int id){
        save[day][hour].add(id); 
    }
    /*Calcular atributo inflowCar*/
    public int inflowCar(int day,int hour){
        int countCar = 0;
        int timeDay = day;
        int timeHour = hour-1;
        if(hour == 0 && day == 0){
            timeDay = 6;
            timeHour = 23;
        }else if(hour == 0){
            timeDay = day-1;
            timeHour = 23;
        }
        for(int i = 0;i<save[timeDay][timeHour].tam();i++){
            int id = save[timeDay][timeHour].get(i);
            if(save[day][hour].contains(id) == true){
                countCar++;
            }
        }
        return save[day][hour].tam()-countCar; 
    }
    /*Calcular atributo outflowCar*/
    public int outflowCar(int day,int hour){
        int countCar = 0;
        int timeDay = day;
        int timeHour = hour+1;
        if(hour == 23 && day == 6){
            timeDay = 0;
            timeHour = 0;
        }else if(hour == 23){
            timeDay = day+1;
            timeHour = 0;
        }
        for(int i = 0;i<save[timeDay][timeHour].tam();i++){
            int id = save[timeDay][timeHour].get(i);
            if(save[day][hour].contains(id) == true){
                countCar++;
            }
        }
        int outFlowCar = save[day][hour].tam()-countCar;
        return outFlowCar;   
    }
    /*Almacenar flujo de salida de coches y número de vehiculos para un día y hora concreto*/
    public void outFlowCarAndNumTaxis(){
        int outFlowCar;
        int numTaxis;
        for(int i = 0; i < 6;i++){
            for(int j = 0; j < 23;j++){
                numTaxis = save[i][j].tam();
                outFlowCar = outflowCar(i,j);
                if(outFlowCar != -1){
                   saveOutFlowAndNumTaxis.add(new SaveOutFlowAndNumTaxis(outFlowCar,numTaxis));
                }
            }
        }
    }
    /*Ordenar de mayor a menor la lista donde almacenamos flujo de salida de coche y número de vehiculas.
    Se utiliza los valores de flujo de salida de coche para ordenar*/
    public void sort(){
        Collections.sort(saveOutFlowAndNumTaxis, new Comparator() {	
            @Override
            public int compare(Object o1, Object o2) {
                SaveOutFlowAndNumTaxis s1 = (SaveOutFlowAndNumTaxis) o1;
                SaveOutFlowAndNumTaxis s2 = (SaveOutFlowAndNumTaxis) o2;
                return new Integer(s2.getOutFlowTaxis()).compareTo(new Integer(s1.getOutFlowTaxis()));
            }
        });
    }
    public void print(){
        for(int i = 0; i < saveOutFlowAndNumTaxis.size();i++){
            System.out.println("Flujo de salida " + saveOutFlowAndNumTaxis.get(i).getOutFlowTaxis());
            System.out.println("Numero de taxis " + saveOutFlowAndNumTaxis.get(i).getNumTaxis());
        }
    }
    /*Calcular n critica*/
    public double calculateCriticN(){
        double criticN = 0;
        int tam  = saveOutFlowAndNumTaxis.size();
        if(tam >= 4){
            tam = 4;
            for(int i = 0; i<4; i++){
                criticN += saveOutFlowAndNumTaxis.get(i).getNumTaxis();
                //System.out.println("Imprimir numero de taxis para calcula N critica " +   saveOutFlowAndNumTaxis.get(i).getNumTaxis());
                //System.out.println("Imprimir numero de taxis de salida para calcula N critica " +   saveOutFlowAndNumTaxis.get(i).getOutFlowTaxis());
            }
        }else{
            for(int i = 0; i<tam; i++){
                criticN += saveOutFlowAndNumTaxis.get(i).getNumTaxis();
            }
        }
        return Math.rint((criticN/tam)*1000)/1000;
    }
    /*Numero de vehiculas para la hora siguiente de una hora concreta */
    public int numberOfTaxisNextHour(int day,int hour){
        int timeDay = day;
        int timeHour = hour+1;
        //int timeHour = hour;
        if(hour == 23 && day == 6){
            timeDay = 0;
            timeHour = 0;
        }else if(hour == 23){
            timeDay = day+1;
            timeHour = 0;
        }
        return save[timeDay][timeHour].tam();
    }
    /*Numero de vehiculos para una hora y dia concreto*/
    public int numberOfTaxisCurrentHour(int day,int hour){
       return save[day][hour].tam();
    }
}
