package Interface;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import org.openstreetmap.gui.jmapviewer.Coordinate;
import org.openstreetmap.gui.jmapviewer.JMapViewerTree;
import org.openstreetmap.gui.jmapviewer.OsmTileLoader;
import org.openstreetmap.gui.jmapviewer.interfaces.TileLoader;
import org.openstreetmap.gui.jmapviewer.interfaces.TileSource;
import org.openstreetmap.gui.jmapviewer.tilesources.OsmTileSource;
/*Clase que contiene las funcionalidades del panel donde se encuentra el mapa que se utiliza para visualizar que parte de oporto se está prediciendo.*/
public class VisualizeMap extends JPanel {
    private JMapViewerTree map = new JMapViewerTree("Zones");
    public VisualizeMap(){
        setSize(400, 400);
        map.getViewer().setTileSource((TileSource) new OsmTileSource.Mapnik());
        map.getViewer().setTileLoader((TileLoader) new OsmTileLoader(map.getViewer()));
        add(map, BorderLayout.CENTER);
    }
    /*Establecer posición del mapa mediante una latitud y longitud*/
    public void setPosition(double latitud,double longitud){
        map.getViewer().setDisplayPosition(new Coordinate(latitud,longitud), 17);
    }

}
